/* REXX CGI example */
/* Finger gateway   */

/* constants */
crlf = d2c(13) || d2c(10)
Title = 'Finger Gateway'

/* HTTP header */
say 'Pragma: no-cache'
say 'Cache-Control: no-cache'
say 'Content-Type: text/html'
say ''
say '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">'
say '<HTML>'
say '<HEAD>'
say '<TITLE>'
say Title
say '</TITLE>'
say '</HEAD>'
say '<BODY bgcolor="#000099" text="#00FF66" LINK="#00ffff" VLINK="#0097ff" ALINK="#79ee35">'

say '<H1>Finger Gateway</H1>'

query_string=value('QUERY_STRING',,'OS2ENVIRONMENT')

who = ''

NFields = ParseQueryString( query_string )
do i = 1 to NFields
    if Parms.Tag.i = 'HOST' then 
    do
        who = Parms.XVal.i
    end
end


if who = '' then 
do
   say 'This is a gateway to finger. Type a user@host combination in'
   say "your browser's finger dialog.<P>"
end
else 
do
   say '<H3><I>Finger to ' who '</I></H3><P>'
   say '<HR>'

   '@finger.exe' who '| RXQUEUE'
   data = '<pre>'
   do queued()
      parse pull what
      if what = d2c(13) | what = d2c(10) then 
         iterate
      data = data || what  || crlf
   end
   data = data || '</pre>'
   say data
   say '<HR>'
end
say '</BODY>'
say "</HTML>"
exit

/* The following code was taken from somewhere */
/* I do not remember where I have got it from  */
ParseQueryString: procedure expose Parms.
  Parse arg P
  i = 1
  do while ((P \= '') & (i < 10))
     Parse var P Parms.Text.i '&' rest
     Parse var Parms.Text.i Parms.Tag.i '=' Parms.KeyVal.i
     Parms.Tag.i = translate( Parms.Tag.i)
     Parms.XVal.i=DecodeKeyVal( Parms.KeyVal.i)
     P = rest
     i = i + 1
  end
  NFields = i - 1
  return NFields

DecodeKeyVal: procedure
  parse arg Code
  Text=''
  Code=translate(Code, ' ', '+')
  rest='%'
  do while (rest\='')
     Parse var Code T '%' rest
     Text=Text || T
     if (rest\='') then
      do
        ch = left( rest,2)
        c=X2C(ch)
        Text=Text || c
        Code=substr( rest, 3)
      end
  end
  return Text

